/*
 * Creare una classe LibroMastro per registrare le vendite di un negozio (vettore di importi double).
 * Dimensionare il vettore con al massimo 1000 elementi.
 * Chiedere all'utente quante vendite vuole inserire (max 1000), controllando la correttezza
 * dell'input. Richiedere gli importi (valori positivi, da controllare) riempiendo il vettore 
 * per il numero di vendite indicato.
 * Il programma deve prevedere i seguenti metodi, richiamati dal programma principale per indicare
 * alcune statistiche sui dati contenuti nel vettore;
 * - totaleVendite(vendite,numVendite): restituisce l'importo totale delle vendite
 * - mediaVendite(vendite,numVendite): restituisce il valore medio di tutte le vendite
 * - venditeAlDiSopra(vendite,numVendite,valoreDiRiferimento): restituisce il numero di vendite che hanno un
 * valore superiore a valoreDiRiferimento, richiesto in input all'utente nel main
 * - importoPiuAlto(vendite,numVendite): restituisce l'importo pi alto fra tutte le vendite
 */

import java.util.*;

public class LibroMastro{

	public static final int MAX_VENDITE = 1000;
	
	public static void main(String[] args){
		
		double[] vendite = new double[MAX_VENDITE];
		Scanner tastiera = new Scanner(System.in);
		
		int numVendite;
		System.out.println("Quante vendite vuoi inserire (massimo "+MAX_VENDITE+")?");
		do{
			numVendite = tastiera.nextInt();
			if(numVendite<0 || numVendite>MAX_VENDITE){
				System.out.println("Il numero di vendite deve essere positivo e al pi "+MAX_VENDITE);
				System.out.println("Inserire nuovamente il numero di vendite");
			}
		}while(numVendite<0 || numVendite>MAX_VENDITE);
		System.out.println("Inserire gli importi delle vendite (valori positivi): ");
		int i=0;
		while(i<numVendite){
			System.out.print("Vendita n"+(i+1)+": ");
			vendite[i]=tastiera.nextDouble();
			if(vendite[i]<=0)
				System.out.println("L'importo inserito non  positivo. Reinserire l'importo.");
			else
				i++;
		}
		
		System.out.println("Il totale delle vendite e': "+totaleVendite(vendite,numVendite));
		System.out.println("La media delle vendite e': "+mediaVendite(vendite,numVendite));
		System.out.print("Inserire il valore di riferimento: ");
		double value = tastiera.nextDouble();
		System.out.println("Il numero di vendite al di sopra del valore di riferimento e': "+venditeAlDiSopra(vendite,numVendite,value));
		System.out.println("L'importo pi alto e' pari a: "+importoPiuAlto(vendite,numVendite));
	
		tastiera.close();
	}

	public static double totaleVendite(double[] v, int n){
		double totale = 0;
		for(int i=0; i<n; i++)
			totale += v[i];
		return totale;
	}
	
	public static double mediaVendite(double[] v, int n){
		return totaleVendite(v,n)/n;
	}
	
	public static int venditeAlDiSopra(double[] v, int n, double valore){
		int numSopra=0;
		for(int i=0; i<n;i++)
			if(v[i] > valore)
				numSopra++;
		return numSopra;
	}
	

	public static double importoPiuAlto(double[] v, int n){
		double importoMax=0; //inizializza a zero cosi' se n vale zero restituisce zero
		for(int i=0; i<n; i++){
			if(v[i]>importoMax)
				importoMax = v[i];
		}
		return importoMax;
	}

	// metodo alternativo in cui si tiene solo la posizione del massimo
	// uno dei due metodi va commentato
	public static double importoPiuAlto(double[] v, int n){
		double importoMax=0;
		if(n>0){
			int max=0;
			for(int i=1; i<n; i++)
				if(v[i] > v[max])
					max = i;
			importoMax = v[max];
		}
		return importoMax;
	}


}
